
;****************      ATmega8   *****************************
;*
;*     TWI = 400Hz,  !
;*    = 100,0Hz
;*   AVR - ATmega8 = 16MHz
;* 
;* ;
;* OutSymbolDisp:   
;* OutPut_SPI:      , (HC595)
;* ReadDATA:       
;* Analysis_Code:    
;* Def_block:         
;* GetSymbol1:        r0
;* Code_51:           
;* SYMBOL1:       
;* Timer_Int2:  /  

;* Fuses:  BODLEVEL=0, BODEN=0, CKSEL=1111, SUT=10

;*******************************************************************************
.nolist
.include "m8def.inc"
.list
;*****  

.def  Save = r9     ;   SREG  
.def  DataSPI = r10 ;      SPI
.def  DPtr = r11	;                 
.def  Cons = r12    ;     = 5 



.def  tmp1 = r16	;   1
.def  tmp2 = r17    ;   2
.def  Anode = r18   ;   ,(  )
.def  time = r19 
.def  loop1 = r20   ;  1,   "" 
.def  loop2 = r21    ;  2,   ""  
.def  CntSymbol = r22;  
.def  PosDisp = r23  ;    
.def  Blank = r24    ;    , ( ) 
.def  CntCol = r25   ;     
;            

;*****  *****


.equ Interval= 194   ;    T2,    ,
                     ;  16- , Interval= 225
.equ    SCL  = PC5	    ; SCL =  C /  5  
.equ    SDA  = PC4	    ; SDA =  C /  4
.equ    nss  = PB2      ; /LCL = PB2,     HC595
.equ    ZeroDisp  = 0b00001000 ;  16- , ZeroDisp = 0
.equ    CntSmax  = 8    ;  16- , CntSmax  = 16
.equ    TimeBlinc2 = 20  ;  16- , TimeBlinc  = 40
.equ    AddrTWI = $A0    ;       I2C
      
.cseg

.org 0
 
rjmp  Initial	         ;       

.org $0004               ;   /    T2
rjmp Timer_Int2

;.org $0009               ;   /    T0
;rjmp Timer_Int0

.org $0011               ;   /    TWI
rjmp ReadDATA

Initial:

ldi   tmp1,High(RamEnd) 
out   sph,tmp1
ldi   tmp1,Low(RamEnd)
out   spl,tmp1	        ;  
ldi tmp1,0b00001000	      
out PortC,tmp1      ;   PORTC  PC3  1
ldi tmp1,0b00001111         	   
out DDRC,tmp1	    ; PC4-PC5  , PC3-PC0  
ldi tmp1,0b00101111 ; SCK=1, MOSI=1, /nss=1,PB1=1,PB0=1,MISO=0
out DDRB,tmp1	    ;  PB3   ,     HC595
ldi tmp1,0b00000010 ; PB1=1  RST,PB0=   
out PortB,tmp1      ;    - ,SCK,MOSI,/nss  
ldi tmp1,0b11111000 ;  7-3  D  ,    
out DDRD,tmp1 
ser tmp1      
out PortD,tmp1      ;   PORTD  1 
;ldi tmp1,12 
;out TWBR,tmp1       ;     TWI (400kHz = f/40)
ldi tmp1,AddrTWI 
out TWAR,tmp1       ;  ,   
ldi  tmp1,(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(1<<TWEN)|(1<<TWIE)
out  TWCR,tmp1  ;     
ldi tmp1,0b00000001
out SPSR,tmp1
ldi tmp1,0b01010000	; SPIE=0,SPE=1,DORD=0,MSTR=1,CPHA=0,CPOL=0,SPR1=SPR0=0
out SPCR,tmp1	        ; f(SCK)=f(.) / 2

ldi tmp1,5
mov Cons,tmp1       ;     
ldi tmp1,0b11111011 ;   
mov Anode,tmp1
clr CntCol
clr CntSymbol
clr DPtr
clr XL
                ;   2
	ldi	tmp1,1<<TOIE2   
	out	TIMSK,tmp1      ;      2		
	ldi	tmp1,Interval	;  2  62   
	out	TCNT2,tmp1		
	ldi	tmp1,4		    ;      64 
	out	TCCR2,tmp1	     

ldi PosDisp,ZeroDisp ;     
ldi loop2,TimeBlinc2       ;   2

;rjmp Service     ;     

ldi tmp1,$4E         ;    , ... 
sts  CodeSymbol1,tmp1
ldi tmp1,$6F        ; 
sts  CodeSymbol2,tmp1
ldi tmp1,$20         ; 
sts  CodeSymbol3,tmp1
ldi tmp1,$44         ; 
sts  CodeSymbol4,tmp1
ldi tmp1,$61         ; 
sts  CodeSymbol5,tmp1
ldi tmp1,$74         ; 
sts  CodeSymbol6,tmp1
ldi tmp1,$61         ; 
sts  CodeSymbol7,tmp1
ldi tmp1,$21         ; 
sts  CodeSymbol8,tmp1
rjmp NoService

Service:

ldi tmp1,$7F        ;     , ... 
sts  CodeSymbol1,tmp1
ldi tmp1,$7F       ; 
sts  CodeSymbol2,tmp1
ldi tmp1,$7F        ; 
sts  CodeSymbol3,tmp1
ldi tmp1,$7F        ; 
sts  CodeSymbol4,tmp1
ldi tmp1,$7F         ; 
sts  CodeSymbol5,tmp1
ldi tmp1,$7F      ; 
sts  CodeSymbol6,tmp1
ldi tmp1,$7F         ; 
sts  CodeSymbol7,tmp1
ldi tmp1,$7F         ; 
sts  CodeSymbol8,tmp1

NoService:

wdr
ldi	tmp1,(1<<WDTOE)|(1<<WDE)
out	WDTCR,tmp1			;  
ldi	tmp1,(1<<WDE)|(1<<WDP0) 
out	WDTCR,tmp1		; :   
					;  (wdr)   33,0 
					;    
					; RESET

sei                  ;   

rjmp Analysis_Code   ;    

OutSymbolDisp:  ;    

cbi PORTB,0          ;   
OutDisp:
cpi  CntCol,5        ;    5    
breq WT3
rjmp OutDisp
WT3:
clr CntCol
dec loop1            ;  1-    "" 
cpi loop1,0
breq WT1
rjmp WT4
WT1:
lds loop1,TimeBlinc1 ;  1-  
dec loop2
cpi loop2,0          ;  2-    "" 
breq WT2
rjmp WT4
WT2:
ldi loop2,TimeBlinc2 ;  2-  
inc XL               ;   ,XL=0,   , XL=1
cpi XL,2             ;     
breq WT8
rjmp WT4
WT8:
clr XL
WT4:
inc CntSymbol        ;   
inc PosDisp          ;    
cpi CntSymbol,CntSmax ;    ,   
breq WT5
cp PosDisp,Blank     ;  "" , (  )
breq WT6
rjmp Analysis_Code   ;    
WT5:
clr CntSymbol        ;   
ldi PosDisp,ZeroDisp ;     
rjmp Analysis_Code   ;    
WT6:
cpi XL,1
breq WT7
rjmp Analysis_Code   ;    
WT7:
ldi tmp1,$20
clr tmp2
rjmp Def_block       ;      


Timer_Int2:     ;    2,  

wdr
    in Save,SREG         ;    
    push tmp1
    push tmp2
    push zl
    push zh
	sbrc Anode,7         ;    0,   
	rjmp WT0
    ldi tmp1,0b11111011  ;     
    mov Anode,tmp1       ;   1-  
	clr DPtr             ;     
WT0:
    rol Anode            ;    
	sec                  ;   
	ldi	tmp1,Interval    ;   2
	out	TCNT2,tmp1
	out	PORTD,Anode	     ;      
    ldi zl,Low(Column1)  ;   SRAM - 
    ldi zh,High(Column1)
    add zl,DPtr       ;      
	ld DataSPI,z         ;    SRAM -     
    rcall OutPut_SPI     ;    SPI  HC595    
    inc DPtr             ;   
    inc CntCol           ;    
    pop zh               ;    
    pop zl
    pop tmp2
    pop tmp1
    out SREG,Save 

    reti

OutPut_SPI:	; 8   SPI, CPHA=0,CPOL=0,   HC595

out  SPDR,DataSPI ;     ,(1 )
spi1:
sbis  SPSR,SPIF	  ;   ,   
rjmp  spi1
nop
sbi   PortB,nss	  ; /LCL =  (. 1),    
nop
nop
nop
nop
nop
cbi   PortB,nss	  ; /LCL =  (. 0),LCL-Latch Clock
nop
out   PORTC,PosDisp     ;   
ret

ReadDATA:    ;     

sbi PORTB,0        ;   
    in Save,SREG   ;    
    push tmp1

              ;   1 
ldi  tmp1, (1<<TWINT)|(1<<TWEN)|(1<<TWEA)  
out  TWCR,tmp1
wait6:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait6
in   tmp1,TWDR
sts  CodeSymbol1,tmp1
              ;   2 
ldi  tmp1, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) 
out  TWCR,tmp1
wait7:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait7
in   tmp1,TWDR
sts  CodeSymbol2,tmp1
               ;   3 
ldi  tmp1, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) 
out  TWCR,tmp1
wait8:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait8
in   tmp1,TWDR
sts  CodeSymbol3,tmp1
              ;   4 
ldi  tmp1, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) 
out  TWCR,tmp1
wait9:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait9
in   tmp1,TWDR
sts  CodeSymbol4,tmp1
               ;   5 
ldi  tmp1, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) 
out  TWCR,tmp1
wait10:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait10
in   tmp1,TWDR
sts  CodeSymbol5,tmp1
               ;   6 
ldi  tmp1, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) 
out  TWCR,tmp1
wait11:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait11
in   tmp1,TWDR
sts  CodeSymbol6,tmp1
              ;   7 
ldi  tmp1, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) 
out  TWCR,tmp1
wait12:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait12
in   tmp1,TWDR
sts  CodeSymbol7,tmp1
               ;   8 
ldi  tmp1, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) 
out  TWCR,tmp1
wait13:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait13
in   tmp1,TWDR
sts  CodeSymbol8,tmp1

;  16-       CodeSymbol9 - CodeSymbol16
;     17  18
               ;   9 
ldi  tmp1, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) 
out  TWCR,tmp1
wait14:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait14
in   tmp1,TWDR   ;     ( )
mov Blank,tmp1
sts  Blank0,tmp1

               ;   10 
ldi  tmp1, (1<<TWINT)|(1<<TWEN)|(0<<TWEA) 
out  TWCR,tmp1
wait15:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait15
in   tmp1,TWDR   ;    "" 
mov loop1,tmp1
sts  TimeBlinc1,tmp1

ldi  tmp1, (1<<TWINT)|(1<<TWEN)|(1<<TWSTO)  ; 
out  TWCR,tmp1

ldi  tmp1,(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(1<<TWEN)|(1<<TWIE)
out  TWCR,tmp1  ;     

    pop tmp1
    out SREG,Save 
cbi PORTB,0        ;   
reti
    
Analysis_Code:  ;    

cpi CntSymbol,8      ; =8,     2    
breq Bloc02
cpi CntSymbol,0		 ; 1    
breq AC0
cpi CntSymbol,1
breq AC1
cpi CntSymbol,2
breq AC2
cpi CntSymbol,3
breq AC3
cpi CntSymbol,4
breq AC4
cpi CntSymbol,5
breq AC5
cpi CntSymbol,6
breq AC6
cpi CntSymbol,7
breq AC7
Bloc02:              ;       
rjmp Bloc2
AC0:
lds tmp1,CodeSymbol1 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC1:
lds tmp1,CodeSymbol2 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC2:
lds tmp1,CodeSymbol3 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,   
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC3:
lds tmp1,CodeSymbol4 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC4:
lds tmp1,CodeSymbol5 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC5:
lds tmp1,CodeSymbol6 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC6:
lds tmp1,CodeSymbol7 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC7:
lds tmp1,CodeSymbol8 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       

Bloc2:               ; 2    ,
cpi CntSymbol,8		 ;  16- 
breq AC8
cpi CntSymbol,9
breq AC9
cpi CntSymbol,10
breq AC10
cpi CntSymbol,11
breq AC11
cpi CntSymbol,12
breq AC12
cpi CntSymbol,13
breq AC13
cpi CntSymbol,14
breq AC14
cpi CntSymbol,15
breq AC15
AC8:
lds tmp1,CodeSymbol9 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC9:
lds tmp1,CodeSymbol10 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC10:
lds tmp1,CodeSymbol11 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,   
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC11:
lds tmp1,CodeSymbol12 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC12:
lds tmp1,CodeSymbol13 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC13:
lds tmp1,CodeSymbol14 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC14:
lds tmp1,CodeSymbol15 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       
AC15:
lds tmp1,CodeSymbol16 ;     
mov tmp2,tmp1         
andi tmp1,$F0        ;   ,    
andi tmp2,$0F     ;   ,      
mul tmp2,Cons        ;   5,  
mov tmp2,R0
rjmp Def_block       ;       

Def_block: ;       

cpi tmp1,$20		;  1 
breq Block1
cpi tmp1,$30		;  2 
breq Block2
cpi tmp1,$40		;  3 
breq Block3
cpi tmp1,$50		;  4 
breq Block4
cpi tmp1,$60		;  5 
breq Block5
cpi tmp1,$70		;  6 
breq Block6
cpi tmp1,$A0		;  7 
breq Block7
cpi tmp1,$B0		;  8 
breq Block8
cpi tmp1,$C0		;  9 
breq Block9
cpi tmp1,$D0		;   10 
breq Block10
cpi tmp1,$E0		;   11 
breq Block11
cpi tmp1,$F0		;   12 
breq Block12
rjmp Error          ;       
Block1:
rjmp Code_51         ;       
Block2:
rjmp Code_52         ;       
Block3:
rjmp Code_53         ;       
Block4:
rjmp Code_54         ;       
Block5:
rjmp Code_55         ;       
Block6:
rjmp Code_56         ;       
Block7:
rjmp Code_57         ;       
Block8:
rjmp Code_58         ;       
Block9:
rjmp Code_59         ;       
Block10:
rjmp Code_510        ;       
Block11:
rjmp Code_511        ;       
Block12:
rjmp Code_512        ;       

GetSymbol1:     ;       r0

ldi zl,Low(SYMBOL1<<1)  ;    Z 
ldi zh,High(SYMBOL1<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_51:  ;       

rcall GetSymbol1    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol1	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol1	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol1	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol1	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol2: ;       r0

ldi zl,Low(SYMBOL2<<1)  ;    Z 
ldi zh,High(SYMBOL2<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_52:  ;       

rcall GetSymbol2    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol2	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol2	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol2	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol2	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol3:     ;       r0

ldi zl,Low(SYMBOL3<<1)  ;    Z 
ldi zh,High(SYMBOL3<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_53:  ;       

rcall GetSymbol3    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol3	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol3	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol3	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol3	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol4:  ;       r0

ldi zl,Low(SYMBOL4<<1)  ;    Z 
ldi zh,High(SYMBOL4<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_54:  ;       

rcall GetSymbol4    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol4	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol4	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol4	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol4	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol5:  ;       r0

ldi zl,Low(SYMBOL5<<1)  ;    Z 
ldi zh,High(SYMBOL5<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_55:  ;       

rcall GetSymbol5    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol5	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol5	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol5	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol5	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol6:   ;       r0

ldi zl,Low(SYMBOL6<<1)  ;    Z 
ldi zh,High(SYMBOL6<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_56:  ;       

rcall GetSymbol6    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol6	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol6	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol6	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol6	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol7:  ;       r0

ldi zl,Low(SYMBOL7<<1)  ;    Z 
ldi zh,High(SYMBOL7<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_57:  ;       

rcall GetSymbol7    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol7	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol7	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol7	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol7	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol8:   ;       r0

ldi zl,Low(SYMBOL8<<1)  ;    Z 
ldi zh,High(SYMBOL8<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_58:  ;       

rcall GetSymbol8    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol8	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol8	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol8	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol8	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol9:   ;       r0

ldi zl,Low(SYMBOL9<<1)  ;    Z 
ldi zh,High(SYMBOL9<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_59:  ;       

rcall GetSymbol9    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol9	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol9	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol9	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol9	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol10:   ;       r0

ldi zl,Low(SYMBOL10<<1)  ;    Z 
ldi zh,High(SYMBOL10<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_510:  ;       

rcall GetSymbol10    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol10	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol10	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol10	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol10	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol11:   ;       r0

ldi zl,Low(SYMBOL11<<1)  ;    Z 
ldi zh,High(SYMBOL11<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_511:  ;       

rcall GetSymbol11    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol11	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol11	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol11	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol11	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol12:   ;       r0

ldi zl,Low(SYMBOL12<<1)  ;    Z 
ldi zh,High(SYMBOL12<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Code_512:  ;       

rcall GetSymbol12    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol12	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol12	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol12	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol12	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    

GetSymbol13:   ;       r0

ldi zl,Low(ERROR1<<1)  ;    Z 
ldi zh,High(ERROR1<<1) ;    
clr tmp1
add zl,tmp2            ;      
adc zh,tmp1
lpm                    ;   -  r0
ret              

Error:  ;       

rcall GetSymbol13    ;  1 
sts Column1,r0         ;   
inc tmp2            ;  
rcall GetSymbol13	;  2 
sts Column2,r0			;   
inc tmp2
rcall GetSymbol13	;  3 	
sts Column3,r0			;   
inc tmp2
rcall GetSymbol13	;  4 
sts Column4,r0			;   
inc tmp2
rcall GetSymbol13	;  5 
sts Column5,r0			;   
rjmp OutSymbolDisp      ;    
 
SYMBOL1:      ;    , 1 

.db 0b00000000,0b00000000  ; ' ' -     = 0, $20 - 
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '!' -     = 5, $21
.db 0b00000000,0b11111010
.db 0b00000000,0b00000000
.db 0b00000000,0b11100000  ; '"' -     = 10, $22
.db 0b00000000,0b11100000
.db 0b00000000, 0b00101000 ; '#' -     = 15, $23
.db 0b11111111,0b00101000
.db 0b11111111,0b00101000
.db 0b00100100,0b01010100  ; '$' -     = 20, $24
.db 0b11111111,0b01010100
.db 0b01001000, 0b11000100 ; '%' -     = 25, $25
.db 0b11001000,0b00010000
.db 0b00100110,0b01000110
.db 0b01101100,0b10010010  ; '&' -     = 30, $26
.db 0b10101010,0b01000100 
.db 0b00000010, 0b00000000 ; ''' -     = 35, $27
.db 0b10100000,0b11000000 
.db 0b00000000,0b00000000
.db 0b00000000,0b00111000  ; '(' -     = 40, $28
.db 0b01000100,0b10000010
.db 0b00000000, 0b00000000 ; ')' -     = 45, $29
.db 0b10000010,0b01000100 
.db 0b00111000,0b00000000
.db 0b00101000,0b00010000  ; '*' -     = 50, $2A
.db 0b01111100,0b00010000
.db 0b00101000, 0b00010000 ; '+' -     = 55, $2B
.db 0b00010000,0b01111100 
.db 0b00010000,0b00010000  
.db 0b00000000,0b00001010  ; ',' -     = 60, $2C
.db 0b00001100,0b00000000 
.db 0b00000000, 0b00010000 ; '-' -     = 65, $2D
.db 0b00010000,0b00010000 
.db 0b00010000,0b00010000  
.db 0b00000000,0b00000110  ; '.' -     = 70, $2E
.db 0b00000110,0b00000000 
.db 0b00000000, 0b00000100 ; '/' -     = 75, $2F
.db 0b00001000,0b00010000 
.db 0b00100000,0b01000000

SYMBOL2:      ;    , 2 

.db 0b01111100,0b10001010  ; '0' -     = 0, $30- 
.db 0b10010010,0b10100010 
.db 0b01111100, 0b00000000 ; '1' -     = 5, $31
.db 0b01000010,0b11111110 
.db 0b00000010,0b00000000
.db 0b01000010,0b10000110  ; '2' -     = 10, $32 
.db 0b10001010,0b10010010
.db 0b01100010, 0b10000100 ; '3' -     = 15, $33
.db 0b10000010,0b10100010
.db 0b11010010,0b10001100
.db 0b00011000,0b00101000  ; '4' -     = 20, $34
.db 0b01001000,0b11111110
.db 0b00001000, 0b11100100 ; '5' -     = 25, $35
.db 0b10100010,0b10100010
.db 0b10100010,0b10011100
.db 0b00111100,0b01010010  ; '6' -     = 30, $36
.db 0b10010010,0b10010010
.db 0b00001100, 0b10000000 ; '7' -     = 35, $37
.db 0b10001110,0b10010000
.db 0b10100000,0b11000000
.db 0b01101100,0b10010010  ; '8' -     = 40, $38
.db 0b10010010,0b10010010
.db 0b01101100, 0b01100000 ; '9' -     = 45, $39
.db 0b10010010,0b10010010
.db 0b10010100,0b01111000
.db 0b00000000,0b01101100  ; ':' -     = 50, $3A
.db 0b01101100,0b00000000
.db 0b00000000, 0b00000000 ; ';' -     = 55, $3B
.db 0b01101010,0b01101100
.db 0b00000000,0b00000000
.db 0b00010000,0b00101000  ; '<' -     = 60, $3C
.db 0b01000100,0b10000010
.db 0b00000000, 0b00101000 ; '=' -     = 65, $3D
.db 0b00101000,0b00101000
.db 0b00101000,0b00101000
.db 0b00000000,0b10000010  ; '>' -     = 70, $3E
.db 0b01000100,0b00101000
.db 0b00010000, 0b01000000 ; '?' -     = 75, $3F
.db 0b10000000,0b10001010 
.db 0b10010000,0b01100000


SYMBOL3:      ;    , 3 

.db 0b01111100,0b10000010  ; '@' -     = 0, $40- 
.db 0b11110010,0b10010010 
.db 0b01100100, 0b01111110 ; 'A' -     = 5, $41
.db 0b10001000,0b10001000 
.db 0b10001000,0b01111110
.db 0b11111110,0b10010010  ; 'B' -     = 10, $42 
.db 0b10010010,0b10010010
.db 0b01101100, 0b01111100 ; 'C' -     = 15, $43
.db 0b10000010,0b10000010
.db 0b10000010,0b01000100
.db 0b11111110,0b10000010  ; 'D' -     = 20, $44
.db 0b10000010,0b01000100
.db 0b00111000, 0b11111110 ; 'E' -     = 25, $45
.db 0b10010010,0b10010010
.db 0b10010010,0b10000010
.db 0b11111110,0b10010000  ; 'F' -     = 30, $46
.db 0b10010000,0b10010000
.db 0b10000000, 0b01111100 ; 'G' -     = 35, $47
.db 0b10000010,0b10010010
.db 0b10010010,0b01011100
.db 0b11111110,0b00010000  ; 'H' -     = 40, $48
.db 0b00010000,0b00010000
.db 0b11111110, 0b00000000 ; 'I' -     = 45, $49
.db 0b10000010,0b11111110
.db 0b10000010,0b00000000
.db 0b00000100,0b00000010  ; 'J' -     = 50, $4A
.db 0b10000010,0b11111100
.db 0b10000000, 0b11111110 ; 'K' -     = 55, $4B
.db 0b00010000,0b00101000
.db 0b01000100,0b10000010
.db 0b11111110,0b00000010  ; 'L' -     = 60, $4C
.db 0b00000010,0b00000010
.db 0b00000010, 0b11111110 ; 'M' -     = 65, $4D
.db 0b01000000,0b00110000
.db 0b01000000,0b11111110
.db 0b11111110,0b00100000  ; 'N' -     = 70, $4E
.db 0b00010000,0b00001000
.db 0b11111110, 0b01111100 ; 'O' -     = 75, $4F
.db 0b10000010,0b10000010 
.db 0b10000010,0b01111100

SYMBOL4:      ;    , 4 

.db 0b11111110,0b10010000  ; 'P' -     = 0, $50- 
.db 0b10010000,0b10010000 
.db 0b01100000, 0b01111100 ; 'Q' -     = 5, $51
.db 0b10000010,0b10001010 
.db 0b10000100,0b01111010
.db 0b11111110,0b10010000  ; 'R' -     = 10, $52 
.db 0b10011000,0b10010100
.db 0b01100010, 0b01100100 ; 'S' -     = 15, $53
.db 0b10010010,0b10010010
.db 0b10010010,0b10001100
.db 0b10000000,0b10000000  ; 'T' -     = 20, $54
.db 0b11111110,0b10000000
.db 0b10000000, 0b11111100 ; 'U' -     = 25, $55
.db 0b00000010,0b00000010
.db 0b00000010,0b11111100
.db 0b11111000,0b00000100  ; 'V' -     = 30, $56
.db 0b00000010,0b00000100
.db 0b11111000, 0b11111100 ; 'W' -     = 35, $57
.db 0b00000010,0b00001110
.db 0b00000010,0b11111100
.db 0b11000110,0b00101000  ; 'X' -     = 40, $58
.db 0b00010000,0b00101000
.db 0b11000110, 0b11100000 ; 'Y' -     = 45, $59
.db 0b00010000,0b00001110
.db 0b00010000,0b11100000
.db 0b10000110,0b10001010  ; 'Z' -     = 50, $5A
.db 0b10010010,0b10100010
.db 0b11000010, 0b00000000 ; '[' -     = 55, $5B
.db 0b11111110,0b10000010
.db 0b10000010,0b00000000
.db 0b01000000,0b00100000  ; '\' -     = 60, $5C
.db 0b00010000,0b00001000
.db 0b00000100, 0b00000000 ; ']' -     = 65, $5D
.db 0b10000010,0b10000010
.db 0b11111110,0b00000000
.db 0b00100000,0b01000000  ; '^' -     = 70, $5E
.db 0b10000000,0b01000000
.db 0b00100000, 0b00000010 ; '_' -     = 75, $5F
.db 0b00000010,0b00000010 
.db 0b00000010,0b00000010

SYMBOL5:      ;    , 5 

.db 0b00000000,0b10000000  ; '`' -     = 0, $60- 
.db 0b01000000,0b00000000 
.db 0b00000000, 0b00000100 ; 'a' -     = 5, $61
.db 0b00101010,0b00101010 
.db 0b00101010,0b00011110
.db 0b11111110,0b00100010  ; 'b' -     = 10, $62
.db 0b00100010,0b00100010
.db 0b00011100, 0b00011100 ; 'c' -     = 15, $63
.db 0b00100010,0b00100010
.db 0b00100010,0b00000100
.db 0b00011100,0b00100010  ; 'd' -     = 20, $64
.db 0b00100010,0b00010010
.db 0b11111110, 0b00011100 ; 'e' -     = 25, $65
.db 0b00101010,0b00101010
.db 0b00101010,0b00011000
.db 0b00010000,0b01111110  ; 'f' -     = 30, $66
.db 0b10010000,0b10000000
.db 0b01000000, 0b00110000 ; 'g' -     = 35, $67
.db 0b01001010,0b01001010
.db 0b01001010,0b01111100
.db 0b11111110,0b00010000  ; 'h' -     = 40, $68
.db 0b00100000,0b00100000
.db 0b00011110, 0b00000000 ; 'i' -     = 45, $69
.db 0b00100010,0b10111110
.db 0b00000010,0b00000000
.db 0b00000100,0b00000010  ; 'j' -     = 50, $6A
.db 0b00100010,0b10111100
.db 0b00000000, 0b11111110 ; 'k' -     = 55, $6B
.db 0b00001000,0b00010100
.db 0b00100010,0b00000000
.db 0b00000000,0b10000010  ; 'l' -     = 60, $6C
.db 0b11111110,0b00000010
.db 0b00000000, 0b00111110 ; 'm' -     = 65, $6D
.db 0b00100000,0b00011000
.db 0b00100000,0b00011110
.db 0b00111110,0b00010000  ; 'n' -     = 70, $6E
.db 0b00100000,0b00100000
.db 0b00011110, 0b00011100 ; 'o' -     = 75, $6F
.db 0b00100010,0b00100010 
.db 0b00100010,0b00011100

SYMBOL6:      ;    , 6 

.db 0b00111110,0b00101000  ; 'p' -     = 0, $70- 
.db 0b00100100,0b00101000 
.db 0b00010000, 0b00010000 ; 'q' -     = 5, $71
.db 0b00101000,0b00101000 
.db 0b00101000,0b00111110
.db 0b00111110,0b00010000  ; 'r' -     = 10, $72 
.db 0b00100000,0b00100000
.db 0b00010000, 0b00010010 ; 's' -     = 15, $73
.db 0b00101010,0b00101010
.db 0b00101010,0b00000100
.db 0b00100000,0b11111100  ; 't' -     = 20, $74
.db 0b00100010,0b00000010
.db 0b00000100, 0b00111100 ; 'u' -     = 25, $75
.db 0b00000010,0b00000010
.db 0b00000100,0b00111110
.db 0b00111000,0b00000100  ; 'v' -     = 30, $76
.db 0b00000010,0b00000100
.db 0b00111000, 0b00111100 ; 'w' -     = 35, $77
.db 0b00000010,0b00000100
.db 0b00000010,0b00111100
.db 0b00100010,0b00010100  ; 'x' -     = 40, $78
.db 0b00001000,0b00010100
.db 0b00100010, 0b00110000 ; 'y' -     = 45, $79
.db 0b00001010,0b00001010
.db 0b00001010,0b00111100
.db 0b00100010,0b00100110  ; 'z' -     = 50, $7A
.db 0b00101010,0b00110010
.db 0b00100010, 0b01100000 ; '' -     = 55, $7B,   
.db 0b10010000,0b10010000                                             
.db 0b01100000,0b00000000
.db 0b01000000,0b10000000  ; '~' -     = 60, $7C
.db 0b01000000,0b01000000
.db 0b10000000, 0b00100000 ; '' -     = 65, $7D, 
.db 0b01000000,0b11111110
.db 0b01000000,0b00100000
.db 0b00000100,0b00000100  ; '' -     = 70, $7E, 
.db 0b11111110,0b00000100
.db 0b00000010, 0b11111111 ; '' -     = 75, $7F, 
.db 0b11111111,0b11111111                                             ; 
.db 0b11111111,0b11111111

SYMBOL7:      ;    , 7 

.db 0b00000000,0b00000000  ; '' -     = 0, $A0- 
.db 0b00000000,0b00000000 
.db 0b00000000, 0b00000000 ; '' -     = 5, $A1- 
.db 0b00000000,0b00000000 
.db 0b00000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 10, $A2-  
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 15, $A3- 
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 20, $A4-   
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 25, $A5-  
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 30, $A6-  
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 35, $A7-  
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00111110,0b10101010  ; '' -     = 40, $A8-  
.db 0b00101010,0b10100010         
.db 0b00000000, 0b00000000 ; '' -     = 45, $A9- 
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 50, $AA- 
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 55, $AB- 
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 60, $AC-  
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 65, $AD- 
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 70, $AE- 
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 75, $AF- 
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000

SYMBOL8:      ;    , 8 

.db 0b00000000,0b00000000  ; '' -     = 0, $B0- 
.db 0b00000000,0b00000000 
.db 0b00000000, 0b00000000 ; '' -     = 5, $B1- 
.db 0b00000000,0b00000000 
.db 0b00000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 10, $B2-  
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 15, $B3- 
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 20, $B4-   
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 25, $B5-  
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 30, $B6-  
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 35, $B7-  
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00011100,0b10101010  ; '' -     = 40, $B8-  
.db 0b00101010,0b10101010
.db 0b00011000, 0b00000000 ; '' -     = 45, $B9- 
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 50, $BA- 
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 55, $BB- 
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 60, $BC-  
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 65, $BD- 
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000
.db 0b00000000,0b00000000  ; '' -     = 70, $BE- 
.db 0b00000000,0b00000000
.db 0b00000000, 0b00000000 ; '' -     = 75, $BF- 
.db 0b00000000,0b00000000
.db 0b10000000,0b00000000

SYMBOL9:      ;    , 9 

.db 0b01111110,0b10001000  ; '' -     = 0, $C0- 
.db 0b10001000,0b10001000 
.db 0b01111110, 0b11111110 ; '' -     = 5, $C1
.db 0b10010010,0b10010010 
.db 0b10010010,0b11001100
.db 0b11111110,0b10010010  ; '' -     = 10, $C2 
.db 0b10010010,0b10010010
.db 0b01101100, 0b11111110 ; '' -     = 15, $C3
.db 0b10000000,0b10000000
.db 0b10000000,0b11000000
.db 0b00000111,0b10001010  ; '' -     = 20, $C4
.db 0b11110010,0b10000010
.db 0b11111111, 0b11111110 ; '' -     = 25, $C5
.db 0b10010010,0b10010010
.db 0b10010010,0b10000010
.db 0b11101110,0b00010000  ; '' -     = 30, $C6
.db 0b11111110,0b00010000
.db 0b11101110, 0b10000010 ; '' -     = 35, $C7
.db 0b10010010,0b10010010
.db 0b10010010,0b01101100
.db 0b11111110,0b00001000  ; '' -     = 40, $C8
.db 0b00010000,0b00100000
.db 0b11111110, 0b00111110 ; '' -     = 45, $C9
.db 0b10000100,0b01001000
.db 0b10010000,0b00111110
.db 0b11111110,0b00010000  ; '' -     = 50, $CA
.db 0b00101000,0b01000100
.db 0b10000010, 0b00000100 ; '' -     = 55, $CB
.db 0b10000010,0b11111100
.db 0b10000000,0b11111110
.db 0b11111110,0b01000000  ; '' -     = 60, $CC
.db 0b00110000,0b01000000
.db 0b11111110, 0b11111110 ; '' -     = 65, $CD
.db 0b00010000,0b00010000
.db 0b00010000,0b11111110
.db 0b01111100,0b10000010  ; '' -     = 70, $CE
.db 0b10000010,0b00000010
.db 0b01111100, 0b11111110 ; '' -     = 75, $CF
.db 0b10000000,0b10000000 
.db 0b10000000,0b11111110

SYMBOL10:      ;    , 10 

.db 0b11111110,0b10010000  ; '' -     = 0, $D0- 
.db 0b10010000,0b10010000 
.db 0b01100000, 0b01111100 ; '' -     = 5, $D1
.db 0b10000010,0b10000010 
.db 0b10000010,0b01000100
.db 0b10000000,0b10000000  ; '' -     = 10, $D2 
.db 0b11111110,0b10000000
.db 0b10000000, 0b11100010 ; '' -     = 15, $D3
.db 0b00010100,0b00001000
.db 0b00010000,0b11100000
.db 0b00111000,0b01000100  ; '' -     = 20, $D4
.db 0b11111110,0b01000100
.db 0b00111000, 0b11000110 ; '' -     = 25, $D5
.db 0b00101000,0b00010000
.db 0b00101000,0b11000110
.db 0b11111110,0b00000010  ; '' -     = 30, $D6
.db 0b00000010,0b00000010
.db 0b11111111, 0b11100000 ; '' -     = 35, $D7
.db 0b00010000,0b00010000
.db 0b00010000,0b11111110
.db 0b11111110,0b00000010  ; '' -     = 40, $D8
.db 0b11111110,0b00000010
.db 0b11111110, 0b11111110 ; '' -     = 45, $D9
.db 0b00000010,0b11111110
.db 0b00000010,0b11111111
.db 0b10000000,0b11111110  ; '' -     = 50, $DA
.db 0b00010010,0b00010010
.db 0b00001100, 0b11111110 ; '' -     = 55, $DB
.db 0b00010010,0b00001100
.db 0b00000000,0b11111110
.db 0b11111110,0b00100010  ; '' -     = 60, $DC
.db 0b00100010,0b00100010
.db 0b00011100, 0b01000100 ; '' -     = 65, $DD
.db 0b10000010,0b10010010
.db 0b10010010,0b01111100
.db 0b11111110,0b00010000  ; '' -     = 70, $DE
.db 0b01111100,0b10000010
.db 0b01111100, 0b01100010 ; '' -     = 75, $DF
.db 0b10010100,0b10011000 
.db 0b10010000,0b11111110

SYMBOL11:      ;    , 11 

.db 0b00000100,0b00101010  ; '' -     = 0, $E0- 
.db 0b00101010,0b00101010 
.db 0b00011110, 0b00111100 ; '' -     = 5, $E1
.db 0b01010010,0b01010010 
.db 0b10010010,0b10001100
.db 0b00111110,0b00101010  ; '' -     = 10, $E2 
.db 0b00101010,0b00010100
.db 0b00000000, 0b00111110 ; '' -     = 15, $E3
.db 0b00100000,0b00100000
.db 0b00100000,0b00110000
.db 0b00000111,0b00101010  ; '' -     = 20, $E4
.db 0b00110010,0b00100010
.db 0b00111111, 0b00011100 ; '' -     = 25, $E5
.db 0b00101010,0b00101010
.db 0b00101010,0b00011000
.db 0b00110110,0b00001000  ; '' -     = 30, $E6
.db 0b00111110,0b00001000
.db 0b00110110, 0b00100010 ; '' -     = 35, $E7
.db 0b00100010,0b00101010
.db 0b00101010,0b00010100
.db 0b00111110,0b00000100  ; '' -     = 40, $E8
.db 0b00001000,0b00010000
.db 0b00111110, 0b00011110 ; '' -     = 45, $E9
.db 0b01000010,0b00100100
.db 0b01001000,0b00011110
.db 0b00111110,0b00001000  ; '' -     = 50, $EA
.db 0b00010100,0b00100010
.db 0b00000000, 0b00000100 ; '' -     = 55, $EB
.db 0b00100010,0b00111100
.db 0b00100000,0b00111110
.db 0b00111110,0b00010000  ; '' -     = 60, $EC
.db 0b00001000,0b00010000
.db 0b00111110, 0b00111110 ; '' -     = 65, $ED
.db 0b00001000,0b00001000
.db 0b00001000,0b00111110
.db 0b00011100,0b00100010  ; '' -     = 70, $EE
.db 0b00100010,0b00100010
.db 0b00011100, 0b00111110 ; '' -     = 75, $EF
.db 0b00100000,0b00100000 
.db 0b00100000,0b00111110

SYMBOL12:      ;    , 12 

.db 0b00111110,0b00101000  ; '' -     = 0, $F0- 
.db 0b00101000,0b00101000 
.db 0b00010000, 0b00011100 ; '' -     = 5, $F1
.db 0b00100010,0b00100010 
.db 0b00100010,0b00000100
.db 0b00100000,0b00100000  ; '' -     = 10, $F2 
.db 0b00111110,0b00100000
.db 0b00100000, 0b00110000 ; '' -     = 15, $F3
.db 0b00001010,0b00001010
.db 0b00001010,0b00111100
.db 0b00001100,0b00010010  ; '' -     = 20, $F4
.db 0b01111111,0b00010010
.db 0b00001100, 0b00100010 ; '' -     = 25, $F5
.db 0b00010100,0b00001000
.db 0b00010100,0b00100010
.db 0b00111110,0b00000010  ; '' -     = 30, $F6
.db 0b00000010,0b00000010
.db 0b00111111, 0b00110000 ; '' -     = 35, $F7
.db 0b00010000,0b00010000
.db 0b00010000,0b00111110
.db 0b00111110,0b00000010  ; '' -     = 40, $F8
.db 0b00111110,0b00000010
.db 0b00111110, 0b00111110 ; '' -     = 45, $F9
.db 0b00000010,0b00111110
.db 0b00000010,0b00111111
.db 0b00100000,0b00111110  ; '' -     = 50, $FA
.db 0b00001010,0b00001010
.db 0b00000100, 0b00111110 ; '' -     = 55, $FB
.db 0b00001010,0b00001010
.db 0b00000100,0b00111110
.db 0b00111110,0b00001010  ; '' -     = 60, $FC
.db 0b00001010,0b00000100
.db 0b00000000, 0b00010100 ; '' -     = 65, $FD
.db 0b00100010,0b00101010
.db 0b00101010,0b00011100
.db 0b00111110,0b00001000  ; '' -     = 70, $FE
.db 0b00011100,0b00100010
.db 0b00011100, 0b00010000 ; '' -     = 75, $FF
.db 0b00101010,0b00101100 
.db 0b00101000,0b00111110

ERROR1:       ;     

.db 0b11111111,0b10100001  ;     "?"  
.db 0b11011011,0b10100001 
.db 0b11111111, 0b11111111
.db 0b10100001,0b11011011
.db 0b10100001,0b11111111
.db 0b11111111,0b10100001
.db 0b11011011,0b10100001
.db 0b11111111, 0b11111111
.db 0b10100001,0b11011011
.db 0b10100001,0b11111111
.db 0b11111111,0b10100001
.db 0b11011011,0b10100001
.db 0b11111111, 0b11111111
.db 0b10100001,0b11011011
.db 0b10100001,0b11111111
.db 0b11111111,0b10100001
.db 0b11011011,0b10100001
.db 0b11111111, 0b11111111
.db 0b10100001,0b11011011
.db 0b10100001,0b11111111
.db 0b11111111,0b10100001
.db 0b11011011,0b10100001
.db 0b11111111, 0b11111111
.db 0b10100001,0b11011011
.db 0b10100001,0b11111111
.db 0b11111111,0b10100001
.db 0b11011011,0b10100001
.db 0b11111111, 0b11111111
.db 0b10100001,0b11011011
.db 0b10100001,0b11111111
.db 0b11111111,0b10100001
.db 0b11011011,0b10100001
.db 0b11111111, 0b11111111
.db 0b10100001,0b11011011
.db 0b10100001,0b11111111
.db 0b11111111,0b10100001
.db 0b11011011,0b10100001
.db 0b11111111, 0b11111111
.db 0b10100001,0b11011011
.db 0b10100001,0b11111111


           ;  RAM
.dseg

Column1: .byte 1   ;   1,     
Column2: .byte 1   ;   2,     
Column3: .byte 1   ;   3,     
Column4: .byte 1   ;   4,     
Column5: .byte 1   ;   5,     
CodeSymbol1: .byte 1   ;  1     
CodeSymbol2: .byte 1   ;  2     
CodeSymbol3: .byte 1   ;  3     
CodeSymbol4: .byte 1   ;  4     
CodeSymbol5: .byte 1   ;  5     
CodeSymbol6: .byte 1   ;  6     
CodeSymbol7: .byte 1   ;  7     
CodeSymbol8: .byte 1   ;  8     
;********************************************************************************
      ;    16- 
CodeSymbol9: .byte 1   ;  9     
CodeSymbol10: .byte 1   ;  10     
CodeSymbol11: .byte 1   ;  11     
CodeSymbol12: .byte 1   ;  12     
CodeSymbol13: .byte 1   ;  13     
CodeSymbol14: .byte 1   ;  14     
CodeSymbol15: .byte 1   ;  15     
CodeSymbol16: .byte 1   ;  16     
;********************************************************************************
Blank0: .byte 1         ;  ""   
TimeBlinc1: .byte 1     ;  "" 

;#########################################################################################

.Exit










   








