
;*******************    **********************************
;*
;*  ATmega8535L-8PU
;*   - 8 
;*   TWI - 100 
;*  :
;*    DS1307
;*    ATmega8-PU
;* 
;* Main:          , ( )
;* View:          
;* ReadRTCcur:       DS1307   
;* InsClock:      
;* Timer_Int1:       
;* WriteRTC:         DS1307 
;* Data_Transmission:    
;* CodeTime:            
;* CodeData:           
;* ConvDay:         Day
;* HexBCD:        
;* 
;* Time:           ""   
;* Write:          ""   
;* Ready:          ""      
;* Minutes:      ""        
;* Hours:        ""        
;* Day:          ""        
;* Date:    ""        
;* Month:   ""        
;* Year:    ""       
;* Control:   "."       
;* Seconds:   ""        
;* Fuses:    CKSEL = 1101, SUT = 11
;***********************************************************************************

.nolist
.include "m8535def.inc"
.list

;*****  *****

.def  cpyL  = r9    ;  
.def  tim3  = r11   ;   3
.def  hexH  = r12   ;   HEX 
.def  hexL  = r13   ;   HEX 
.def  tmp1  = r16	;  
.def  tmp2  = r17	;  
.def  tmp3  = r18   ;  
.def  tim1  = r19   ;   1
.def  tim2  = r20   ;   2
.def  BCD0  = r21   ;   BCD 
.def  BCD1  = r22   ;   BCD 

.def  Cnt   = r24   ;  

          
;*****  *****

.equ  SDA  = PC1         ;  TWI,SDA =  C /  1
.equ  SCL  = PC0         ;  TWI,SCL =  C /  0

.equ  TimeH = 241        ;      1  
.equ  TimeL = 0          ;        


.cseg

.org 0
rjmp  Initial

.org 8            ;   /    T1
rjmp Timer_Int1


Initial:	;  

ldi   tmp1, Low(RAMEND)
out   SPL, tmp1
ldi   tmp1, High(RAMEND)
out   SPH, tmp1	        ;   

ldi   tmp1,0b11010000   ; PC4, PC6, PC7 - 
out   PortC,tmp1        ; SCL,SDA- 
ldi   tmp1,0b00000000   
out   DDRC,tmp1         
  
ldi   tmp1,0b11100000	; 
out   PortB,tmp1	    ; PB5, PB6, PB7 - 
ldi   tmp1,0b00000000	
out   DDRB,tmp1	        

ldi   tmp1,$20 
out   TWBR,tmp1         ;     TWI (100kHz)
;ldi   tmp1,2 
;out   TWBR,tmp1         ;     TWI (400kHz)

ldi   tmp1,5	        ;  
out   TCCR0,tmp1	    ;  T/C0,  . = 1024

ldi tmp1,0              ;  "" , "" 
sts Data_on_Disp8,tmp1  
ldi tmp1,40             ;  "",  
sts Data_on_Disp9,tmp1
rcall View              ;   

sei                     ;   

rjmp Main

Wait1000:	;   1000 
ldi   tmp1,0	    ;   
out   TCNT0,tmp1	;  T/C0
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0
ldi   tim2,32	    ; 32   
Wait:
in    tmp1,TIFR	    ;    TIFR
sbrs  tmp1,TOV0	;   ,    
rjmp  Wait	        ;   
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0
dec   tim2
brne  Wait	        ; 32  = 1000 
ret

Main:  ;  

ldi tmp1,$0A          ;  "" ,    3
sts Data_on_Disp8,tmp1 
ldi tmp1,40             ;  "",  
sts Data_on_Disp9,tmp1
Main2:
clr  tmp1
in  tmp1,PINC         ;    SB1
sbrs tmp1,4           ;   ,   
rjmp InsClock         ;  
rcall ReadRTCcur
rcall ConvDay
rcall CodeTime
rcall Data_Transmission
rcall Wait1000
clr  tmp1
in  tmp1,PINB         ;    SB2
sbrs tmp1,5           ;   ,   
rjmp OutData          ;     
rjmp Main2

OutData:   ;     

ldi tmp1,0              ;  "" , "" 
sts Data_on_Disp8,tmp1  
ldi tmp1,40             ;  "",  
sts Data_on_Disp9,tmp1
OutData2:
rcall ReadRTCcur
rcall CodeData
rcall Data_Transmission
rcall Wait1000
clr  tmp1
in  tmp1,PINC         ;    SB6
sbrc tmp1,7           ;   ,  
rjmp OutData2
rjmp Main


ReadRTCcur:  ;     DS1307   

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait24:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait24

ldi  r29,$D0     ;   TWDR   
out  TWDR,r29
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait25:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait25

ldi  r28,$01 
          
out  TWDR,r28    ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait26:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait26

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait27:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait27

ldi  r29,$D1   ;   TWDR   , 
out  TWDR,r29
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait28:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait28
                ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait29:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait29
in   BCD0,TWDR
sts  SD0,BCD0  ;    
               ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait30:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait30
in   BCD0,TWDR
sts  SD1,BCD0  ;    
              ;    ( )
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait31:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait31
in   BCD0,TWDR
sts  SD2,BCD0  ;     

             ;    ( )
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait32:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait32
in   BCD0,TWDR
sts  SD3,BCD0  ;     
             ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait33:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait33
in   BCD0,TWDR
sts  SD4,BCD0  ;     
             ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (0<<TWEA)
out  TWCR,tmp1
wait33a:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait33a
in   BCD0,TWDR
sts  SD5,BCD0  ;    
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret   

InsClock:         ;  

rcall Time
ldi  r28,0
ldi  r27,0b10000000  ;   ,  
rcall WriteRTC
ldi  r28,1           ;   
ldi  tmp1,0          ;    0
mov  hexL,tmp1
ldi  tmp1,TimeH      ;    1    
out  TCNT1H,tmp1
ldi  tmp1,TimeL 
out  TCNT1L,tmp1
ldi   tmp1,5	     ;  
out   TCCR1B,tmp1    ;  T/C1,  . = 1024
ldi  tmp1,(1<<TOIE1)
out  TIMSK,tmp1      ;    
REP4:
clr tmp3
in  tmp3,PINB        ;    SB3
sbrc tmp3,6          ;   ,    
rjmp REP4
ldi tmp1,0
out TIMSK,tmp1       ;   
ldi   tmp1,0	     ;  
out   TCCR1B,tmp1    ;  T/C1
ldi r28,0            ;   
ldi r27,0
rcall WriteRTC
rcall Ready
rjmp Main            ;     

Timer_Int1:		     ;    T1

clr  tmp1
in  tmp1,PINC        ;    SB1
sbrs tmp1,4          ;   ,    
inc  R28             ;    DS1307, UP
clr  tmp1
in  tmp1,PINB        ;    SB2
sbrs tmp1,5          ;   ,    
dec  R28             ;    DS1307, DOWN
cpi  R28,0           ;  00   
breq Sel0
cpi  R28,1           ;  01  
breq Sel1
cpi  R28,2           ;  02  
breq Sel2
cpi  R28,3           ;  03  
breq Sel3
cpi  R28,4           ;  04  
breq Sel4
cpi  R28,5           ;  05  
breq Sel5
cpi  R28,6           ;  06   
breq Sel6
cpi  R28,7           ;  07  'Control'
breq Sel7
Sel0:
rcall Seconds         ;    
rcall Data_Transmission
rjmp  Home
Sel1:
rcall Minutes         ;    
rcall Data_Transmission
rjmp  Home
Sel2:
rcall Hours           ;    
rcall Data_Transmission
rjmp  Home
Sel3:
rcall Day             ;    
rcall Data_Transmission
rjmp  Home 
Sel4:
rcall Date            ;    
rcall Data_Transmission
rjmp  Home
Sel5:
rcall Month           ;    
rcall Data_Transmission
rjmp  Home
Sel6:
rcall Year            ;    
rcall Data_Transmission
rjmp  Home
Sel7:
rcall Control         ;    
rcall Data_Transmission
rjmp  Home

Home:       ;   

clr  tmp1
in  tmp1,PINC        ;    SB5
sbrs tmp1,6          ;   ,    
inc  hexL            ;     DS1307, UP
mov  hexH,hexL
clr  tmp1
in  tmp1,PINC        ;    SB6
sbrs tmp1,7          ;   ,    
dec  hexL            ;     DS1307, DOWN
mov  hexH,hexL 
rcall HexBCD
mov  r27,BCD0        ;    
mov tmp1,R27         ;          
andi tmp1,$F0        
swap tmp1            
ori tmp1,$30;
sts Data_on_Disp0,tmp1
mov tmp2,R27          
andi tmp2,$0F        
ori tmp2,$30         
sts Data_on_Disp1,tmp2 
clr  tmp1
in  tmp1,PINB        ;    SB4
sbrs tmp1,7          ;   ,     
rjmp Write           ;     DS1307
Return:
ldi  tmp1,TimeH      ;    1    
out  TCNT1H,tmp1
ldi  tmp1,TimeL 
out  TCNT1L,tmp1
reti                 ;     

Time: ;   ""   

ldi tmp1,$20
sts Data_on_Disp0,tmp1
ldi tmp1,$C2
sts Data_on_Disp1,tmp1
ldi tmp1,$F0
sts Data_on_Disp2,tmp1
ldi tmp1,$E5
sts Data_on_Disp3,tmp1
ldi tmp1,$EC
sts Data_on_Disp4,tmp1
ldi tmp1,$FF
sts Data_on_Disp5,tmp1
ldi tmp1,$20
sts Data_on_Disp6,tmp1
ldi tmp1,$20
sts Data_on_Disp7,tmp1
ldi tmp1,0
sts Data_on_Disp8,tmp1  ;  "" 
ldi tmp1,30             ;  "",  
sts Data_on_Disp9,tmp1
rcall Data_Transmission
rcall Wait1000
rcall Wait1000
ret

Write: ;   ""   

rcall WriteRTC
ldi tmp1,$20
sts Data_on_Disp0,tmp1
ldi tmp1,$C7
sts Data_on_Disp1,tmp1
ldi tmp1,$E0
sts Data_on_Disp2,tmp1
ldi tmp1,$EF
sts Data_on_Disp3,tmp1
ldi tmp1,$E8
sts Data_on_Disp4,tmp1
ldi tmp1,$F1
sts Data_on_Disp5,tmp1
ldi tmp1,$FC
sts Data_on_Disp6,tmp1
ldi tmp1,$20
sts Data_on_Disp7,tmp1
rcall Data_Transmission
rcall Wait1000
rcall Wait1000
rjmp Return

Ready: ;   ""      

ldi tmp1,$20
sts Data_on_Disp0,tmp1
ldi tmp1,$C3
sts Data_on_Disp1,tmp1
ldi tmp1,$EE
sts Data_on_Disp2,tmp1
ldi tmp1,$F2
sts Data_on_Disp3,tmp1
ldi tmp1,$EE
sts Data_on_Disp4,tmp1
ldi tmp1,$E2
sts Data_on_Disp5,tmp1
ldi tmp1,$EE
sts Data_on_Disp6,tmp1
ldi tmp1,$20
sts Data_on_Disp7,tmp1
rcall Data_Transmission
rcall Wait1000
rcall Wait1000
ret

Minutes: ;   ""        

ldi tmp1,$CC
sts Data_on_Disp2,tmp1
ldi tmp1,$E8
sts Data_on_Disp3,tmp1
ldi tmp1,$ED
sts Data_on_Disp4,tmp1
ldi tmp1,$F3
sts Data_on_Disp5,tmp1
ldi tmp1,$F2
sts Data_on_Disp6,tmp1
ldi tmp1,$E0
sts Data_on_Disp7,tmp1
ret

Hours: ;   ""        

ldi tmp1,$20
sts Data_on_Disp2,tmp1
ldi tmp1,$D7
sts Data_on_Disp3,tmp1
ldi tmp1,$E0
sts Data_on_Disp4,tmp1
ldi tmp1,$F1
sts Data_on_Disp5,tmp1
ldi tmp1,$20
sts Data_on_Disp6,tmp1
ldi tmp1,$20
sts Data_on_Disp7,tmp1
ret

Day: ;   ""        

ldi tmp1,$20
sts Data_on_Disp2,tmp1
ldi tmp1,$C4
sts Data_on_Disp3,tmp1
ldi tmp1,$E5
sts Data_on_Disp4,tmp1
ldi tmp1,$ED
sts Data_on_Disp5,tmp1
ldi tmp1,$FC
sts Data_on_Disp6,tmp1
ldi tmp1,$20
sts Data_on_Disp7,tmp1
ret

Date: ;   ""        

ldi tmp1,$20
sts Data_on_Disp2,tmp1
ldi tmp1,$D7
sts Data_on_Disp3,tmp1
ldi tmp1,$E8
sts Data_on_Disp4,tmp1
ldi tmp1,$F1
sts Data_on_Disp5,tmp1
ldi tmp1,$EB
sts Data_on_Disp6,tmp1
ldi tmp1,$EE
sts Data_on_Disp7,tmp1
ret

Month: ;   ""        

ldi tmp1,$20
sts Data_on_Disp2,tmp1
ldi tmp1,$CC
sts Data_on_Disp3,tmp1
ldi tmp1,$E5
sts Data_on_Disp4,tmp1
ldi tmp1,$F1
sts Data_on_Disp5,tmp1
ldi tmp1,$FF
sts Data_on_Disp6,tmp1
ldi tmp1,$F6
sts Data_on_Disp7,tmp1
ret

Year: ;   ""       

ldi tmp1,$20
sts Data_on_Disp2,tmp1
ldi tmp1,$C3
sts Data_on_Disp3,tmp1
ldi tmp1,$EE
sts Data_on_Disp4,tmp1
ldi tmp1,$E4
sts Data_on_Disp5,tmp1
ldi tmp1,$20
sts Data_on_Disp6,tmp1
ldi tmp1,$20
sts Data_on_Disp7,tmp1
ret

Control: ;   "."       

ldi tmp1,$CA
sts Data_on_Disp2,tmp1
ldi tmp1,$EE
sts Data_on_Disp3,tmp1
ldi tmp1,$ED
sts Data_on_Disp4,tmp1
ldi tmp1,$F2
sts Data_on_Disp5,tmp1
ldi tmp1,$F0
sts Data_on_Disp6,tmp1
ldi tmp1,$2E
sts Data_on_Disp7,tmp1
ret

Seconds: ;   ""        

ldi tmp1,$D1
sts Data_on_Disp2,tmp1
ldi tmp1,$E5
sts Data_on_Disp3,tmp1
ldi tmp1,$EA
sts Data_on_Disp4,tmp1
ldi tmp1,$F3
sts Data_on_Disp5,tmp1
ldi tmp1,$ED
sts Data_on_Disp6,tmp1
ldi tmp1,$E4
sts Data_on_Disp7,tmp1
ret
 
WriteRTC:    ;     DS1307 

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait20:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait20

ldi  r29,$D0         ;   
out  TWDR,r29
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait21:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait21

out  TWDR,r28  ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait22:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait22

out  TWDR,r27  ;   TWDR 
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait23:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait23

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

View: ;  

ldi tmp1,$CC
sts Data_on_Disp0,tmp1
ldi tmp1,$E0
sts Data_on_Disp1,tmp1
ldi tmp1,$EB
sts Data_on_Disp2,tmp1
ldi tmp1,$FB
sts Data_on_Disp3,tmp1
ldi tmp1,$F8
sts Data_on_Disp4,tmp1
ldi tmp1,$31
sts Data_on_Disp5,tmp1
ldi tmp1,$2E
sts Data_on_Disp6,tmp1
ldi tmp1,$34
sts Data_on_Disp7,tmp1
rcall Data_Transmission
rcall Wait1000
rcall Wait1000
ret

Data_Transmission:    ;  

ldi  tmp1,(1<<TWINT) | (1<<TWSTA)|(0<<TWSTO)|(1<<TWEN) 
out  TWCR,tmp1  ;     
wait34:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait34

ldi tmp1,$A0
out  TWDR,tmp1 ;  
ldi  tmp1, (1<<TWINT) |(0<<TWSTA)|(0<<TWSTO)| (1<<TWEN)
out  TWCR,tmp1
wait35:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait35

lds tmp1,Data_on_Disp0
out  TWDR,tmp1  ;   TWDR 
ldi  tmp1, (1<<TWINT) |(0<<TWSTA)|(0<<TWSTO)| (1<<TWEN)
out  TWCR,tmp1
wait36:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait36

lds tmp1,Data_on_Disp1
out  TWDR,tmp1  ;   TWDR 
ldi  tmp1, (1<<TWINT) |(0<<TWSTA)|(0<<TWSTO)| (1<<TWEN)
out  TWCR,tmp1
wait37:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait37

lds tmp1,Data_on_Disp2
out  TWDR,tmp1  ;   TWDR 
ldi  tmp1, (1<<TWINT) |(0<<TWSTA)|(0<<TWSTO)| (1<<TWEN)
out  TWCR,tmp1
wait38:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait38

lds tmp1,Data_on_Disp3
out  TWDR,tmp1  ;   TWDR 
ldi  tmp1, (1<<TWINT) |(0<<TWSTA)|(0<<TWSTO)| (1<<TWEN)
out  TWCR,tmp1
wait39:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait39

lds tmp1,Data_on_Disp4
out  TWDR,tmp1  ;   TWDR 
ldi  tmp1, (1<<TWINT) |(0<<TWSTA)|(0<<TWSTO)| (1<<TWEN)
out  TWCR,tmp1
wait40:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait40

lds tmp1,Data_on_Disp5
out  TWDR,tmp1  ;   TWDR 
ldi  tmp1, (1<<TWINT) |(0<<TWSTA)|(0<<TWSTO)| (1<<TWEN)
out  TWCR,tmp1
wait41:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait41

lds tmp1,Data_on_Disp6
out  TWDR,tmp1  ;   TWDR 
ldi  tmp1, (1<<TWINT) |(0<<TWSTA)|(0<<TWSTO)| (1<<TWEN)
out  TWCR,tmp1
wait42:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait42

lds tmp1,Data_on_Disp7
out  TWDR,tmp1  ;   TWDR 
ldi  tmp1, (1<<TWINT) |(0<<TWSTA)|(0<<TWSTO)| (1<<TWEN)
out  TWCR,tmp1
wait43:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait43

lds tmp1,Data_on_Disp8
out  TWDR,tmp1  ;   TWDR 
ldi  tmp1, (1<<TWINT) |(0<<TWSTA)|(0<<TWSTO)| (1<<TWEN)
out  TWCR,tmp1
wait44:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait44

lds tmp1,Data_on_Disp9
out  TWDR,tmp1  ;   TWDR 
ldi  tmp1, (1<<TWINT) |(0<<TWSTA)|(0<<TWSTO)| (1<<TWEN)
out  TWCR,tmp1
wait45:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait45

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

CodeTime: ;        

lds tmp1,SD1           ;    ()  
mov tmp2,tmp1          ;    
andi tmp1,$F0          ;     
swap tmp1              ;     
ori tmp1,$30           ;    ( ) 
sts Data_on_Disp0,tmp1 ;    
andi tmp2,$0F          ;     
ori tmp2,$30           ;    ( )
sts Data_on_Disp1,tmp2 ;    
lds tmp1,SD0           ;    ()  
mov tmp2,tmp1          ;    
andi tmp1,$F0          ;     
swap tmp1              ;     
ori tmp1,$30           ;    ( )
sts Data_on_Disp3,tmp1 ;    
andi tmp2,$0F          ;     
ori tmp2,$30           ;    ( )
sts Data_on_Disp4,tmp2 ;    
ldi tmp1,$3A           ;      ':', 
sts Data_on_Disp2,tmp1 ;     
ldi tmp1,$20           ;   
sts Data_on_Disp5,tmp1 ;     
lds tmp1,SD2_1         ;    
sts Data_on_Disp6,tmp1 ;     
lds tmp1,SD2_2         ;    
sts Data_on_Disp7,tmp1 ;     
ret

CodeData: ;       

lds tmp1,SD3;
mov tmp2,tmp1;
andi tmp1,$F0;
swap tmp1;
ori tmp1,$30;
sts Data_on_Disp0,tmp1 
andi tmp2,$0F;
ori tmp2,$30;
sts Data_on_Disp1,tmp2 
lds tmp1,SD4;
mov tmp2,tmp1;
andi tmp1,$F0;
swap tmp1;
ori tmp1,$30;
sts Data_on_Disp3,tmp1 
andi tmp2,$0F;
ori tmp2,$30;
sts Data_on_Disp4,tmp2

ldi tmp1,$2E
sts Data_on_Disp2,tmp1
sts Data_on_Disp5,tmp1

lds tmp1,SD5;
mov tmp2,tmp1;
andi tmp1,$F0;
swap tmp1;
ori tmp1,$30;
sts Data_on_Disp6,tmp1 
andi tmp2,$0F;
ori tmp2,$30;
sts Data_on_Disp7,tmp2 
ret

ConvDay:        ;    Day

lds  tmp3,SD2       ;    
andi  tmp3,$07      ; ,   3,2,1   
cpi   tmp3,$01      ;  1, 
breq  CD0 
cpi   tmp3,$02      ;  2, 
breq  CD1
cpi   tmp3,$03      ;  3, 
breq  CD2
cpi   tmp3,$04      ;  4, 
breq  CD3
cpi   tmp3,$05      ;  5, 
breq  CD4
cpi   tmp3,$06      ;  6, 
breq  CD5
cpi   tmp3,$07      ;  7, 
breq  CD6
CD0:
ldi tmp1,$CF     ;   '','',   
sts SD2_1,tmp1
ldi tmp1,$CD
sts SD2_2,tmp1
ret
CD1:
ldi tmp1,$C2     ;   '','',   
sts SD2_1,tmp1
ldi tmp1,$D2
sts SD2_2,tmp1
ret
CD2:
ldi tmp1,$D1     ;   '','',   
sts SD2_1,tmp1
ldi tmp1,$D0
sts SD2_2,tmp1
ret
CD3:
ldi tmp1,$D7     ;   '','',   
sts SD2_1,tmp1
ldi tmp1,$D2
sts SD2_2,tmp1
ret
CD4:
ldi tmp1,$CF     ;   '','',   
sts SD2_1,tmp1
ldi tmp1,$D2
sts SD2_2,tmp1
ret
CD5:
ldi tmp1,$D1     ;   '','',   
sts SD2_1,tmp1
ldi tmp1,$C1
sts SD2_2,tmp1
ret
CD6:
ldi tmp1,$C2     ;   '','',   
sts SD2_1,tmp1
ldi tmp1,$D1
sts SD2_2,tmp1
ret

HexBCD:	        ; xx (Hex) -> 0abc (BCD)
rcall Div10	    ; hexH / 10, -  tmp1
mov   BCD0,tmp1	;   hexH, tmp1 =  1
rcall Div10
swap  tmp1      ;  2   
or    BCD0,tmp1 ;   2  1  BCD0
rcall Div10	
mov   BCD1,tmp1	;   4  3  BCD1
ret

Div10:	
clr  tmp1
lsl  hexH
rol  tmp1	    ;     10  
ldi  Cnt,7	    ;   7 
Loop10:
lsl  hexH	    ;     1 
rol  tmp1	    ;   tmp1
subi tmp1,10	; ;  > 10 ?
brlo HB1	    ; ,  
inc  hexH       ;    1
rjmp HB2
HB1:
subi tmp1,-10	;   
HB2:
dec  Cnt	    ;   
brne Loop10	
ret

;****************************************************************************

.dseg

SD0: .byte 1     ; 
SD1: .byte 1     ; 
SD2: .byte 1     ;    BCD 
SD2_1: .byte 1   ;    
SD2_2: .byte 1   ;    
SD3: .byte 1     ;  
SD4: .byte 1     ; 
SD5: .byte 1     ; 
Data_on_Disp0: .byte 1   ;    , 1 
Data_on_Disp1: .byte 1   ;    , 2  
Data_on_Disp2: .byte 1   ;    , 3 
Data_on_Disp3: .byte 1   ;    , 4 
Data_on_Disp4: .byte 1   ;    , 5 
Data_on_Disp5: .byte 1   ;    , 6  
Data_on_Disp6: .byte 1   ;    , 7 
Data_on_Disp7: .byte 1   ;    , 8 
Data_on_Disp8: .byte 1   ;    ,  
Data_on_Disp9: .byte 1   ;    ,  "" 

;******************************************************************************************
;******************************************************************************************
.Exit







